<template>
  <div
    :style="{width:props.dimensions.width+'px',height:props.dimensions.height+'px'}">
    <NodeResizer :min-width="96 / 2.54/2" :min-height="96 / 2.54/2" :max-width="pageSize.width"
                 :max-height="pageSize.height" color="#000"
                 v-if="!props.isView && !props.isHideHandle && props.selected" />
    <div class="custom-node"
         :style="{ width:props.dimensions.width+'px',lineHeight:props.dimensions.height+'px',height:props.dimensions.height+'px',pointerEvents:props.isView?'auto': 'none'}">
      <img
        v-if="eleData"
        :width="props.dimensions.width+'px'"
        :height="props.dimensions.height+'px'"
        :style="{ width:props.dimensions.width+'px',height:props.dimensions.height+'px',objectFit:'contain' }"
        :id="'barcode'+props.id+props.index" />
    </div>
  </div>
</template>
<script setup>
import JsBarcode from 'jsbarcode';
import { defineProps } from 'vue';
import { NodeResizer } from '@vue-flow/node-resizer';


const props = defineProps({
  id: {
    type: String,
    required: false
  },
  index: {
    type: Number,
    required: false
  },
  isView: {
    type: Boolean,
    required: false
  },
  isHideHandle: {
    type: Boolean,
    required: false
  },
  selected: {
    type: Boolean,
    required: false
  },
  data: {
    type: Object,
    required: true
  },
  dimensions: {
    type: Object,
    required: true
  },
  pageSize: {
    type: Object,
    required: true
  },
  pageData: {
    type: Object,
    required: false
  }

});
const eleData = ref('');
const getEleData = () => {
  if (props.isView) {
    eleData.value = props.data.options.field ? props.pageData?.[props.data.options.field] : props.data.options.default;
  } else {
    eleData.value = props.data.options.default || '1234567890abc';
  }
};
onMounted(() => {
  getEleData();
  nextTick(() => {
    if (eleData.value) {
      JsBarcode('#barcode' + props.id + props.index, eleData.value, {
        format: 'CODE128',
        lineColor: '#000',
        displayValue: true
      });
    }
  });
});
watch(() => JSON.parse(JSON.stringify(props.data.options.default)), (obj1, obj2) => {
  if (JSON.stringify(obj1) !== JSON.stringify(obj2)) {
    getEleData();
    nextTick(() => {
      if (eleData.value) {
        JsBarcode('#barcode' + props.id + props.index, eleData.value, {
          format: 'CODE128',
          lineColor: '#000',
          displayValue: true
        });
      }
    });
  }
}, { deep: true });
</script>
<style scoped>
.custom-node {
  position: absolute;
}
</style>

